# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.29.0
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' MunicipalityFinancial Class
#'
#' @field fiscal_year 
#' @field current_assets 
#' @field non_current_assets 
#' @field deferred_outflows 
#' @field total_assets 
#' @field total_assets_plus_deferred_outflows 
#' @field current_liabilities 
#' @field current_portion_of_long_term_debt 
#' @field net_pension_liability 
#' @field net_opeb_liability 
#' @field all_other_long_term_debt 
#' @field total_liabilities 
#' @field deferred_inflows 
#' @field total_liabilities_plus_deferred_inflows 
#' @field total_net_position 
#' @field total_unrestricted_net_position 
#' @field total_expenses 
#' @field charges_for_services 
#' @field operating_grants_and_contributions 
#' @field capital_grants_and_contributions 
#' @field general_revenues 
#' @field other_revenues 
#' @field total_revenues 
#' @field change_in_net_assets 
#' @field non_spendable_general_fund_balance 
#' @field restricted_general_fund_balance 
#' @field committed_general_fund_balance 
#' @field unassigned_general_fund_balance 
#' @field assigned_general_fund_balance 
#' @field total_general_fund_balance 
#' @field non_spendable_governmental_fund_balance 
#' @field restricted_governmental_fund_balance 
#' @field committed_governmental_fund_balance 
#' @field unassigned_governmental_fund_balance 
#' @field assigned_governmental_fund_balance 
#' @field total_governmental_fund_balance 
#' @field general_fund_revenues 
#' @field general_fund_expenditures 
#' @field general_fund_revenues_over_under_expenditure 
#' @field governmental_fund_revenues 
#' @field governmental_fund_expenditures 
#' @field governmental_fund_revenues_over_under_expenditure 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
MunicipalityFinancial <- R6::R6Class(
  'MunicipalityFinancial',
  public = list(
    `fiscal_year` = NA,
    `current_assets` = NA,
    `non_current_assets` = NA,
    `deferred_outflows` = NA,
    `total_assets` = NA,
    `total_assets_plus_deferred_outflows` = NA,
    `current_liabilities` = NA,
    `current_portion_of_long_term_debt` = NA,
    `net_pension_liability` = NA,
    `net_opeb_liability` = NA,
    `all_other_long_term_debt` = NA,
    `total_liabilities` = NA,
    `deferred_inflows` = NA,
    `total_liabilities_plus_deferred_inflows` = NA,
    `total_net_position` = NA,
    `total_unrestricted_net_position` = NA,
    `total_expenses` = NA,
    `charges_for_services` = NA,
    `operating_grants_and_contributions` = NA,
    `capital_grants_and_contributions` = NA,
    `general_revenues` = NA,
    `other_revenues` = NA,
    `total_revenues` = NA,
    `change_in_net_assets` = NA,
    `non_spendable_general_fund_balance` = NA,
    `restricted_general_fund_balance` = NA,
    `committed_general_fund_balance` = NA,
    `unassigned_general_fund_balance` = NA,
    `assigned_general_fund_balance` = NA,
    `total_general_fund_balance` = NA,
    `non_spendable_governmental_fund_balance` = NA,
    `restricted_governmental_fund_balance` = NA,
    `committed_governmental_fund_balance` = NA,
    `unassigned_governmental_fund_balance` = NA,
    `assigned_governmental_fund_balance` = NA,
    `total_governmental_fund_balance` = NA,
    `general_fund_revenues` = NA,
    `general_fund_expenditures` = NA,
    `general_fund_revenues_over_under_expenditure` = NA,
    `governmental_fund_revenues` = NA,
    `governmental_fund_expenditures` = NA,
    `governmental_fund_revenues_over_under_expenditure` = NA,
    initialize = function(`fiscal_year`, `current_assets`, `non_current_assets`, `deferred_outflows`, `total_assets`, `total_assets_plus_deferred_outflows`, `current_liabilities`, `current_portion_of_long_term_debt`, `net_pension_liability`, `net_opeb_liability`, `all_other_long_term_debt`, `total_liabilities`, `deferred_inflows`, `total_liabilities_plus_deferred_inflows`, `total_net_position`, `total_unrestricted_net_position`, `total_expenses`, `charges_for_services`, `operating_grants_and_contributions`, `capital_grants_and_contributions`, `general_revenues`, `other_revenues`, `total_revenues`, `change_in_net_assets`, `non_spendable_general_fund_balance`, `restricted_general_fund_balance`, `committed_general_fund_balance`, `unassigned_general_fund_balance`, `assigned_general_fund_balance`, `total_general_fund_balance`, `non_spendable_governmental_fund_balance`, `restricted_governmental_fund_balance`, `committed_governmental_fund_balance`, `unassigned_governmental_fund_balance`, `assigned_governmental_fund_balance`, `total_governmental_fund_balance`, `general_fund_revenues`, `general_fund_expenditures`, `general_fund_revenues_over_under_expenditure`, `governmental_fund_revenues`, `governmental_fund_expenditures`, `governmental_fund_revenues_over_under_expenditure`){
      if (!missing(`fiscal_year`)) {
        self$`fiscal_year` <- `fiscal_year`
      }
      if (!missing(`current_assets`)) {
        self$`current_assets` <- `current_assets`
      }
      if (!missing(`non_current_assets`)) {
        self$`non_current_assets` <- `non_current_assets`
      }
      if (!missing(`deferred_outflows`)) {
        self$`deferred_outflows` <- `deferred_outflows`
      }
      if (!missing(`total_assets`)) {
        self$`total_assets` <- `total_assets`
      }
      if (!missing(`total_assets_plus_deferred_outflows`)) {
        self$`total_assets_plus_deferred_outflows` <- `total_assets_plus_deferred_outflows`
      }
      if (!missing(`current_liabilities`)) {
        self$`current_liabilities` <- `current_liabilities`
      }
      if (!missing(`current_portion_of_long_term_debt`)) {
        self$`current_portion_of_long_term_debt` <- `current_portion_of_long_term_debt`
      }
      if (!missing(`net_pension_liability`)) {
        self$`net_pension_liability` <- `net_pension_liability`
      }
      if (!missing(`net_opeb_liability`)) {
        self$`net_opeb_liability` <- `net_opeb_liability`
      }
      if (!missing(`all_other_long_term_debt`)) {
        self$`all_other_long_term_debt` <- `all_other_long_term_debt`
      }
      if (!missing(`total_liabilities`)) {
        self$`total_liabilities` <- `total_liabilities`
      }
      if (!missing(`deferred_inflows`)) {
        self$`deferred_inflows` <- `deferred_inflows`
      }
      if (!missing(`total_liabilities_plus_deferred_inflows`)) {
        self$`total_liabilities_plus_deferred_inflows` <- `total_liabilities_plus_deferred_inflows`
      }
      if (!missing(`total_net_position`)) {
        self$`total_net_position` <- `total_net_position`
      }
      if (!missing(`total_unrestricted_net_position`)) {
        self$`total_unrestricted_net_position` <- `total_unrestricted_net_position`
      }
      if (!missing(`total_expenses`)) {
        self$`total_expenses` <- `total_expenses`
      }
      if (!missing(`charges_for_services`)) {
        self$`charges_for_services` <- `charges_for_services`
      }
      if (!missing(`operating_grants_and_contributions`)) {
        self$`operating_grants_and_contributions` <- `operating_grants_and_contributions`
      }
      if (!missing(`capital_grants_and_contributions`)) {
        self$`capital_grants_and_contributions` <- `capital_grants_and_contributions`
      }
      if (!missing(`general_revenues`)) {
        self$`general_revenues` <- `general_revenues`
      }
      if (!missing(`other_revenues`)) {
        self$`other_revenues` <- `other_revenues`
      }
      if (!missing(`total_revenues`)) {
        self$`total_revenues` <- `total_revenues`
      }
      if (!missing(`change_in_net_assets`)) {
        self$`change_in_net_assets` <- `change_in_net_assets`
      }
      if (!missing(`non_spendable_general_fund_balance`)) {
        self$`non_spendable_general_fund_balance` <- `non_spendable_general_fund_balance`
      }
      if (!missing(`restricted_general_fund_balance`)) {
        self$`restricted_general_fund_balance` <- `restricted_general_fund_balance`
      }
      if (!missing(`committed_general_fund_balance`)) {
        self$`committed_general_fund_balance` <- `committed_general_fund_balance`
      }
      if (!missing(`unassigned_general_fund_balance`)) {
        self$`unassigned_general_fund_balance` <- `unassigned_general_fund_balance`
      }
      if (!missing(`assigned_general_fund_balance`)) {
        self$`assigned_general_fund_balance` <- `assigned_general_fund_balance`
      }
      if (!missing(`total_general_fund_balance`)) {
        self$`total_general_fund_balance` <- `total_general_fund_balance`
      }
      if (!missing(`non_spendable_governmental_fund_balance`)) {
        self$`non_spendable_governmental_fund_balance` <- `non_spendable_governmental_fund_balance`
      }
      if (!missing(`restricted_governmental_fund_balance`)) {
        self$`restricted_governmental_fund_balance` <- `restricted_governmental_fund_balance`
      }
      if (!missing(`committed_governmental_fund_balance`)) {
        self$`committed_governmental_fund_balance` <- `committed_governmental_fund_balance`
      }
      if (!missing(`unassigned_governmental_fund_balance`)) {
        self$`unassigned_governmental_fund_balance` <- `unassigned_governmental_fund_balance`
      }
      if (!missing(`assigned_governmental_fund_balance`)) {
        self$`assigned_governmental_fund_balance` <- `assigned_governmental_fund_balance`
      }
      if (!missing(`total_governmental_fund_balance`)) {
        self$`total_governmental_fund_balance` <- `total_governmental_fund_balance`
      }
      if (!missing(`general_fund_revenues`)) {
        self$`general_fund_revenues` <- `general_fund_revenues`
      }
      if (!missing(`general_fund_expenditures`)) {
        self$`general_fund_expenditures` <- `general_fund_expenditures`
      }
      if (!missing(`general_fund_revenues_over_under_expenditure`)) {
        self$`general_fund_revenues_over_under_expenditure` <- `general_fund_revenues_over_under_expenditure`
      }
      if (!missing(`governmental_fund_revenues`)) {
        self$`governmental_fund_revenues` <- `governmental_fund_revenues`
      }
      if (!missing(`governmental_fund_expenditures`)) {
        self$`governmental_fund_expenditures` <- `governmental_fund_expenditures`
      }
      if (!missing(`governmental_fund_revenues_over_under_expenditure`)) {
        self$`governmental_fund_revenues_over_under_expenditure` <- `governmental_fund_revenues_over_under_expenditure`
      }
    },
    toJSON = function() {
      MunicipalityFinancialObject <- list()
      if (!is.null(self$`fiscal_year`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`fiscal_year`) && ((length(self$`fiscal_year`) == 0) || ((length(self$`fiscal_year`) != 0 && R6::is.R6(self$`fiscal_year`[[1]]))))) {
          MunicipalityFinancialObject[['fiscal_year']] <- lapply(self$`fiscal_year`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['fiscal_year']] <- jsonlite::toJSON(self$`fiscal_year`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`current_assets`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`current_assets`) && ((length(self$`current_assets`) == 0) || ((length(self$`current_assets`) != 0 && R6::is.R6(self$`current_assets`[[1]]))))) {
          MunicipalityFinancialObject[['current_assets']] <- lapply(self$`current_assets`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['current_assets']] <- jsonlite::toJSON(self$`current_assets`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`non_current_assets`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`non_current_assets`) && ((length(self$`non_current_assets`) == 0) || ((length(self$`non_current_assets`) != 0 && R6::is.R6(self$`non_current_assets`[[1]]))))) {
          MunicipalityFinancialObject[['non_current_assets']] <- lapply(self$`non_current_assets`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['non_current_assets']] <- jsonlite::toJSON(self$`non_current_assets`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`deferred_outflows`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`deferred_outflows`) && ((length(self$`deferred_outflows`) == 0) || ((length(self$`deferred_outflows`) != 0 && R6::is.R6(self$`deferred_outflows`[[1]]))))) {
          MunicipalityFinancialObject[['deferred_outflows']] <- lapply(self$`deferred_outflows`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['deferred_outflows']] <- jsonlite::toJSON(self$`deferred_outflows`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_assets`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_assets`) && ((length(self$`total_assets`) == 0) || ((length(self$`total_assets`) != 0 && R6::is.R6(self$`total_assets`[[1]]))))) {
          MunicipalityFinancialObject[['total_assets']] <- lapply(self$`total_assets`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_assets']] <- jsonlite::toJSON(self$`total_assets`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_assets_plus_deferred_outflows`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_assets_plus_deferred_outflows`) && ((length(self$`total_assets_plus_deferred_outflows`) == 0) || ((length(self$`total_assets_plus_deferred_outflows`) != 0 && R6::is.R6(self$`total_assets_plus_deferred_outflows`[[1]]))))) {
          MunicipalityFinancialObject[['total_assets_plus_deferred_outflows']] <- lapply(self$`total_assets_plus_deferred_outflows`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_assets_plus_deferred_outflows']] <- jsonlite::toJSON(self$`total_assets_plus_deferred_outflows`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`current_liabilities`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`current_liabilities`) && ((length(self$`current_liabilities`) == 0) || ((length(self$`current_liabilities`) != 0 && R6::is.R6(self$`current_liabilities`[[1]]))))) {
          MunicipalityFinancialObject[['current_liabilities']] <- lapply(self$`current_liabilities`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['current_liabilities']] <- jsonlite::toJSON(self$`current_liabilities`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`current_portion_of_long_term_debt`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`current_portion_of_long_term_debt`) && ((length(self$`current_portion_of_long_term_debt`) == 0) || ((length(self$`current_portion_of_long_term_debt`) != 0 && R6::is.R6(self$`current_portion_of_long_term_debt`[[1]]))))) {
          MunicipalityFinancialObject[['current_portion_of_long_term_debt']] <- lapply(self$`current_portion_of_long_term_debt`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['current_portion_of_long_term_debt']] <- jsonlite::toJSON(self$`current_portion_of_long_term_debt`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`net_pension_liability`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`net_pension_liability`) && ((length(self$`net_pension_liability`) == 0) || ((length(self$`net_pension_liability`) != 0 && R6::is.R6(self$`net_pension_liability`[[1]]))))) {
          MunicipalityFinancialObject[['net_pension_liability']] <- lapply(self$`net_pension_liability`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['net_pension_liability']] <- jsonlite::toJSON(self$`net_pension_liability`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`net_opeb_liability`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`net_opeb_liability`) && ((length(self$`net_opeb_liability`) == 0) || ((length(self$`net_opeb_liability`) != 0 && R6::is.R6(self$`net_opeb_liability`[[1]]))))) {
          MunicipalityFinancialObject[['net_opeb_liability']] <- lapply(self$`net_opeb_liability`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['net_opeb_liability']] <- jsonlite::toJSON(self$`net_opeb_liability`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`all_other_long_term_debt`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`all_other_long_term_debt`) && ((length(self$`all_other_long_term_debt`) == 0) || ((length(self$`all_other_long_term_debt`) != 0 && R6::is.R6(self$`all_other_long_term_debt`[[1]]))))) {
          MunicipalityFinancialObject[['all_other_long_term_debt']] <- lapply(self$`all_other_long_term_debt`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['all_other_long_term_debt']] <- jsonlite::toJSON(self$`all_other_long_term_debt`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_liabilities`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_liabilities`) && ((length(self$`total_liabilities`) == 0) || ((length(self$`total_liabilities`) != 0 && R6::is.R6(self$`total_liabilities`[[1]]))))) {
          MunicipalityFinancialObject[['total_liabilities']] <- lapply(self$`total_liabilities`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_liabilities']] <- jsonlite::toJSON(self$`total_liabilities`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`deferred_inflows`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`deferred_inflows`) && ((length(self$`deferred_inflows`) == 0) || ((length(self$`deferred_inflows`) != 0 && R6::is.R6(self$`deferred_inflows`[[1]]))))) {
          MunicipalityFinancialObject[['deferred_inflows']] <- lapply(self$`deferred_inflows`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['deferred_inflows']] <- jsonlite::toJSON(self$`deferred_inflows`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_liabilities_plus_deferred_inflows`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_liabilities_plus_deferred_inflows`) && ((length(self$`total_liabilities_plus_deferred_inflows`) == 0) || ((length(self$`total_liabilities_plus_deferred_inflows`) != 0 && R6::is.R6(self$`total_liabilities_plus_deferred_inflows`[[1]]))))) {
          MunicipalityFinancialObject[['total_liabilities_plus_deferred_inflows']] <- lapply(self$`total_liabilities_plus_deferred_inflows`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_liabilities_plus_deferred_inflows']] <- jsonlite::toJSON(self$`total_liabilities_plus_deferred_inflows`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_net_position`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_net_position`) && ((length(self$`total_net_position`) == 0) || ((length(self$`total_net_position`) != 0 && R6::is.R6(self$`total_net_position`[[1]]))))) {
          MunicipalityFinancialObject[['total_net_position']] <- lapply(self$`total_net_position`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_net_position']] <- jsonlite::toJSON(self$`total_net_position`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_unrestricted_net_position`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_unrestricted_net_position`) && ((length(self$`total_unrestricted_net_position`) == 0) || ((length(self$`total_unrestricted_net_position`) != 0 && R6::is.R6(self$`total_unrestricted_net_position`[[1]]))))) {
          MunicipalityFinancialObject[['total_unrestricted_net_position']] <- lapply(self$`total_unrestricted_net_position`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_unrestricted_net_position']] <- jsonlite::toJSON(self$`total_unrestricted_net_position`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_expenses`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_expenses`) && ((length(self$`total_expenses`) == 0) || ((length(self$`total_expenses`) != 0 && R6::is.R6(self$`total_expenses`[[1]]))))) {
          MunicipalityFinancialObject[['total_expenses']] <- lapply(self$`total_expenses`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_expenses']] <- jsonlite::toJSON(self$`total_expenses`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`charges_for_services`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`charges_for_services`) && ((length(self$`charges_for_services`) == 0) || ((length(self$`charges_for_services`) != 0 && R6::is.R6(self$`charges_for_services`[[1]]))))) {
          MunicipalityFinancialObject[['charges_for_services']] <- lapply(self$`charges_for_services`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['charges_for_services']] <- jsonlite::toJSON(self$`charges_for_services`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`operating_grants_and_contributions`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`operating_grants_and_contributions`) && ((length(self$`operating_grants_and_contributions`) == 0) || ((length(self$`operating_grants_and_contributions`) != 0 && R6::is.R6(self$`operating_grants_and_contributions`[[1]]))))) {
          MunicipalityFinancialObject[['operating_grants_and_contributions']] <- lapply(self$`operating_grants_and_contributions`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['operating_grants_and_contributions']] <- jsonlite::toJSON(self$`operating_grants_and_contributions`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`capital_grants_and_contributions`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`capital_grants_and_contributions`) && ((length(self$`capital_grants_and_contributions`) == 0) || ((length(self$`capital_grants_and_contributions`) != 0 && R6::is.R6(self$`capital_grants_and_contributions`[[1]]))))) {
          MunicipalityFinancialObject[['capital_grants_and_contributions']] <- lapply(self$`capital_grants_and_contributions`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['capital_grants_and_contributions']] <- jsonlite::toJSON(self$`capital_grants_and_contributions`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`general_revenues`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`general_revenues`) && ((length(self$`general_revenues`) == 0) || ((length(self$`general_revenues`) != 0 && R6::is.R6(self$`general_revenues`[[1]]))))) {
          MunicipalityFinancialObject[['general_revenues']] <- lapply(self$`general_revenues`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['general_revenues']] <- jsonlite::toJSON(self$`general_revenues`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`other_revenues`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`other_revenues`) && ((length(self$`other_revenues`) == 0) || ((length(self$`other_revenues`) != 0 && R6::is.R6(self$`other_revenues`[[1]]))))) {
          MunicipalityFinancialObject[['other_revenues']] <- lapply(self$`other_revenues`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['other_revenues']] <- jsonlite::toJSON(self$`other_revenues`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_revenues`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_revenues`) && ((length(self$`total_revenues`) == 0) || ((length(self$`total_revenues`) != 0 && R6::is.R6(self$`total_revenues`[[1]]))))) {
          MunicipalityFinancialObject[['total_revenues']] <- lapply(self$`total_revenues`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_revenues']] <- jsonlite::toJSON(self$`total_revenues`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`change_in_net_assets`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`change_in_net_assets`) && ((length(self$`change_in_net_assets`) == 0) || ((length(self$`change_in_net_assets`) != 0 && R6::is.R6(self$`change_in_net_assets`[[1]]))))) {
          MunicipalityFinancialObject[['change_in_net_assets']] <- lapply(self$`change_in_net_assets`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['change_in_net_assets']] <- jsonlite::toJSON(self$`change_in_net_assets`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`non_spendable_general_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`non_spendable_general_fund_balance`) && ((length(self$`non_spendable_general_fund_balance`) == 0) || ((length(self$`non_spendable_general_fund_balance`) != 0 && R6::is.R6(self$`non_spendable_general_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['non_spendable_general_fund_balance']] <- lapply(self$`non_spendable_general_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['non_spendable_general_fund_balance']] <- jsonlite::toJSON(self$`non_spendable_general_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`restricted_general_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`restricted_general_fund_balance`) && ((length(self$`restricted_general_fund_balance`) == 0) || ((length(self$`restricted_general_fund_balance`) != 0 && R6::is.R6(self$`restricted_general_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['restricted_general_fund_balance']] <- lapply(self$`restricted_general_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['restricted_general_fund_balance']] <- jsonlite::toJSON(self$`restricted_general_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`committed_general_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`committed_general_fund_balance`) && ((length(self$`committed_general_fund_balance`) == 0) || ((length(self$`committed_general_fund_balance`) != 0 && R6::is.R6(self$`committed_general_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['committed_general_fund_balance']] <- lapply(self$`committed_general_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['committed_general_fund_balance']] <- jsonlite::toJSON(self$`committed_general_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`unassigned_general_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`unassigned_general_fund_balance`) && ((length(self$`unassigned_general_fund_balance`) == 0) || ((length(self$`unassigned_general_fund_balance`) != 0 && R6::is.R6(self$`unassigned_general_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['unassigned_general_fund_balance']] <- lapply(self$`unassigned_general_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['unassigned_general_fund_balance']] <- jsonlite::toJSON(self$`unassigned_general_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`assigned_general_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`assigned_general_fund_balance`) && ((length(self$`assigned_general_fund_balance`) == 0) || ((length(self$`assigned_general_fund_balance`) != 0 && R6::is.R6(self$`assigned_general_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['assigned_general_fund_balance']] <- lapply(self$`assigned_general_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['assigned_general_fund_balance']] <- jsonlite::toJSON(self$`assigned_general_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_general_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_general_fund_balance`) && ((length(self$`total_general_fund_balance`) == 0) || ((length(self$`total_general_fund_balance`) != 0 && R6::is.R6(self$`total_general_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['total_general_fund_balance']] <- lapply(self$`total_general_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_general_fund_balance']] <- jsonlite::toJSON(self$`total_general_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`non_spendable_governmental_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`non_spendable_governmental_fund_balance`) && ((length(self$`non_spendable_governmental_fund_balance`) == 0) || ((length(self$`non_spendable_governmental_fund_balance`) != 0 && R6::is.R6(self$`non_spendable_governmental_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['non_spendable_governmental_fund_balance']] <- lapply(self$`non_spendable_governmental_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['non_spendable_governmental_fund_balance']] <- jsonlite::toJSON(self$`non_spendable_governmental_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`restricted_governmental_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`restricted_governmental_fund_balance`) && ((length(self$`restricted_governmental_fund_balance`) == 0) || ((length(self$`restricted_governmental_fund_balance`) != 0 && R6::is.R6(self$`restricted_governmental_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['restricted_governmental_fund_balance']] <- lapply(self$`restricted_governmental_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['restricted_governmental_fund_balance']] <- jsonlite::toJSON(self$`restricted_governmental_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`committed_governmental_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`committed_governmental_fund_balance`) && ((length(self$`committed_governmental_fund_balance`) == 0) || ((length(self$`committed_governmental_fund_balance`) != 0 && R6::is.R6(self$`committed_governmental_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['committed_governmental_fund_balance']] <- lapply(self$`committed_governmental_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['committed_governmental_fund_balance']] <- jsonlite::toJSON(self$`committed_governmental_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`unassigned_governmental_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`unassigned_governmental_fund_balance`) && ((length(self$`unassigned_governmental_fund_balance`) == 0) || ((length(self$`unassigned_governmental_fund_balance`) != 0 && R6::is.R6(self$`unassigned_governmental_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['unassigned_governmental_fund_balance']] <- lapply(self$`unassigned_governmental_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['unassigned_governmental_fund_balance']] <- jsonlite::toJSON(self$`unassigned_governmental_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`assigned_governmental_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`assigned_governmental_fund_balance`) && ((length(self$`assigned_governmental_fund_balance`) == 0) || ((length(self$`assigned_governmental_fund_balance`) != 0 && R6::is.R6(self$`assigned_governmental_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['assigned_governmental_fund_balance']] <- lapply(self$`assigned_governmental_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['assigned_governmental_fund_balance']] <- jsonlite::toJSON(self$`assigned_governmental_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_governmental_fund_balance`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_governmental_fund_balance`) && ((length(self$`total_governmental_fund_balance`) == 0) || ((length(self$`total_governmental_fund_balance`) != 0 && R6::is.R6(self$`total_governmental_fund_balance`[[1]]))))) {
          MunicipalityFinancialObject[['total_governmental_fund_balance']] <- lapply(self$`total_governmental_fund_balance`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['total_governmental_fund_balance']] <- jsonlite::toJSON(self$`total_governmental_fund_balance`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`general_fund_revenues`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`general_fund_revenues`) && ((length(self$`general_fund_revenues`) == 0) || ((length(self$`general_fund_revenues`) != 0 && R6::is.R6(self$`general_fund_revenues`[[1]]))))) {
          MunicipalityFinancialObject[['general_fund_revenues']] <- lapply(self$`general_fund_revenues`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['general_fund_revenues']] <- jsonlite::toJSON(self$`general_fund_revenues`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`general_fund_expenditures`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`general_fund_expenditures`) && ((length(self$`general_fund_expenditures`) == 0) || ((length(self$`general_fund_expenditures`) != 0 && R6::is.R6(self$`general_fund_expenditures`[[1]]))))) {
          MunicipalityFinancialObject[['general_fund_expenditures']] <- lapply(self$`general_fund_expenditures`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['general_fund_expenditures']] <- jsonlite::toJSON(self$`general_fund_expenditures`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`general_fund_revenues_over_under_expenditure`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`general_fund_revenues_over_under_expenditure`) && ((length(self$`general_fund_revenues_over_under_expenditure`) == 0) || ((length(self$`general_fund_revenues_over_under_expenditure`) != 0 && R6::is.R6(self$`general_fund_revenues_over_under_expenditure`[[1]]))))) {
          MunicipalityFinancialObject[['general_fund_revenues_over_under_expenditure']] <- lapply(self$`general_fund_revenues_over_under_expenditure`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['general_fund_revenues_over_under_expenditure']] <- jsonlite::toJSON(self$`general_fund_revenues_over_under_expenditure`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`governmental_fund_revenues`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`governmental_fund_revenues`) && ((length(self$`governmental_fund_revenues`) == 0) || ((length(self$`governmental_fund_revenues`) != 0 && R6::is.R6(self$`governmental_fund_revenues`[[1]]))))) {
          MunicipalityFinancialObject[['governmental_fund_revenues']] <- lapply(self$`governmental_fund_revenues`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['governmental_fund_revenues']] <- jsonlite::toJSON(self$`governmental_fund_revenues`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`governmental_fund_expenditures`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`governmental_fund_expenditures`) && ((length(self$`governmental_fund_expenditures`) == 0) || ((length(self$`governmental_fund_expenditures`) != 0 && R6::is.R6(self$`governmental_fund_expenditures`[[1]]))))) {
          MunicipalityFinancialObject[['governmental_fund_expenditures']] <- lapply(self$`governmental_fund_expenditures`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['governmental_fund_expenditures']] <- jsonlite::toJSON(self$`governmental_fund_expenditures`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`governmental_fund_revenues_over_under_expenditure`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`governmental_fund_revenues_over_under_expenditure`) && ((length(self$`governmental_fund_revenues_over_under_expenditure`) == 0) || ((length(self$`governmental_fund_revenues_over_under_expenditure`) != 0 && R6::is.R6(self$`governmental_fund_revenues_over_under_expenditure`[[1]]))))) {
          MunicipalityFinancialObject[['governmental_fund_revenues_over_under_expenditure']] <- lapply(self$`governmental_fund_revenues_over_under_expenditure`, function(x) x$toJSON())
        } else {
          MunicipalityFinancialObject[['governmental_fund_revenues_over_under_expenditure']] <- jsonlite::toJSON(self$`governmental_fund_revenues_over_under_expenditure`, auto_unbox = TRUE)
        }
      }

      MunicipalityFinancialObject
    },
    fromJSON = function(MunicipalityFinancialJson) {
      MunicipalityFinancialObject <- jsonlite::fromJSON(MunicipalityFinancialJson)
      if (!is.null(MunicipalityFinancialObject$`fiscal_year`)) {
        self$`fiscal_year` <- MunicipalityFinancialObject$`fiscal_year`
      }
      if (!is.null(MunicipalityFinancialObject$`current_assets`)) {
        self$`current_assets` <- MunicipalityFinancialObject$`current_assets`
      }
      if (!is.null(MunicipalityFinancialObject$`non_current_assets`)) {
        self$`non_current_assets` <- MunicipalityFinancialObject$`non_current_assets`
      }
      if (!is.null(MunicipalityFinancialObject$`deferred_outflows`)) {
        self$`deferred_outflows` <- MunicipalityFinancialObject$`deferred_outflows`
      }
      if (!is.null(MunicipalityFinancialObject$`total_assets`)) {
        self$`total_assets` <- MunicipalityFinancialObject$`total_assets`
      }
      if (!is.null(MunicipalityFinancialObject$`total_assets_plus_deferred_outflows`)) {
        self$`total_assets_plus_deferred_outflows` <- MunicipalityFinancialObject$`total_assets_plus_deferred_outflows`
      }
      if (!is.null(MunicipalityFinancialObject$`current_liabilities`)) {
        self$`current_liabilities` <- MunicipalityFinancialObject$`current_liabilities`
      }
      if (!is.null(MunicipalityFinancialObject$`current_portion_of_long_term_debt`)) {
        self$`current_portion_of_long_term_debt` <- MunicipalityFinancialObject$`current_portion_of_long_term_debt`
      }
      if (!is.null(MunicipalityFinancialObject$`net_pension_liability`)) {
        self$`net_pension_liability` <- MunicipalityFinancialObject$`net_pension_liability`
      }
      if (!is.null(MunicipalityFinancialObject$`net_opeb_liability`)) {
        self$`net_opeb_liability` <- MunicipalityFinancialObject$`net_opeb_liability`
      }
      if (!is.null(MunicipalityFinancialObject$`all_other_long_term_debt`)) {
        self$`all_other_long_term_debt` <- MunicipalityFinancialObject$`all_other_long_term_debt`
      }
      if (!is.null(MunicipalityFinancialObject$`total_liabilities`)) {
        self$`total_liabilities` <- MunicipalityFinancialObject$`total_liabilities`
      }
      if (!is.null(MunicipalityFinancialObject$`deferred_inflows`)) {
        self$`deferred_inflows` <- MunicipalityFinancialObject$`deferred_inflows`
      }
      if (!is.null(MunicipalityFinancialObject$`total_liabilities_plus_deferred_inflows`)) {
        self$`total_liabilities_plus_deferred_inflows` <- MunicipalityFinancialObject$`total_liabilities_plus_deferred_inflows`
      }
      if (!is.null(MunicipalityFinancialObject$`total_net_position`)) {
        self$`total_net_position` <- MunicipalityFinancialObject$`total_net_position`
      }
      if (!is.null(MunicipalityFinancialObject$`total_unrestricted_net_position`)) {
        self$`total_unrestricted_net_position` <- MunicipalityFinancialObject$`total_unrestricted_net_position`
      }
      if (!is.null(MunicipalityFinancialObject$`total_expenses`)) {
        self$`total_expenses` <- MunicipalityFinancialObject$`total_expenses`
      }
      if (!is.null(MunicipalityFinancialObject$`charges_for_services`)) {
        self$`charges_for_services` <- MunicipalityFinancialObject$`charges_for_services`
      }
      if (!is.null(MunicipalityFinancialObject$`operating_grants_and_contributions`)) {
        self$`operating_grants_and_contributions` <- MunicipalityFinancialObject$`operating_grants_and_contributions`
      }
      if (!is.null(MunicipalityFinancialObject$`capital_grants_and_contributions`)) {
        self$`capital_grants_and_contributions` <- MunicipalityFinancialObject$`capital_grants_and_contributions`
      }
      if (!is.null(MunicipalityFinancialObject$`general_revenues`)) {
        self$`general_revenues` <- MunicipalityFinancialObject$`general_revenues`
      }
      if (!is.null(MunicipalityFinancialObject$`other_revenues`)) {
        self$`other_revenues` <- MunicipalityFinancialObject$`other_revenues`
      }
      if (!is.null(MunicipalityFinancialObject$`total_revenues`)) {
        self$`total_revenues` <- MunicipalityFinancialObject$`total_revenues`
      }
      if (!is.null(MunicipalityFinancialObject$`change_in_net_assets`)) {
        self$`change_in_net_assets` <- MunicipalityFinancialObject$`change_in_net_assets`
      }
      if (!is.null(MunicipalityFinancialObject$`non_spendable_general_fund_balance`)) {
        self$`non_spendable_general_fund_balance` <- MunicipalityFinancialObject$`non_spendable_general_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`restricted_general_fund_balance`)) {
        self$`restricted_general_fund_balance` <- MunicipalityFinancialObject$`restricted_general_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`committed_general_fund_balance`)) {
        self$`committed_general_fund_balance` <- MunicipalityFinancialObject$`committed_general_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`unassigned_general_fund_balance`)) {
        self$`unassigned_general_fund_balance` <- MunicipalityFinancialObject$`unassigned_general_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`assigned_general_fund_balance`)) {
        self$`assigned_general_fund_balance` <- MunicipalityFinancialObject$`assigned_general_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`total_general_fund_balance`)) {
        self$`total_general_fund_balance` <- MunicipalityFinancialObject$`total_general_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`non_spendable_governmental_fund_balance`)) {
        self$`non_spendable_governmental_fund_balance` <- MunicipalityFinancialObject$`non_spendable_governmental_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`restricted_governmental_fund_balance`)) {
        self$`restricted_governmental_fund_balance` <- MunicipalityFinancialObject$`restricted_governmental_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`committed_governmental_fund_balance`)) {
        self$`committed_governmental_fund_balance` <- MunicipalityFinancialObject$`committed_governmental_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`unassigned_governmental_fund_balance`)) {
        self$`unassigned_governmental_fund_balance` <- MunicipalityFinancialObject$`unassigned_governmental_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`assigned_governmental_fund_balance`)) {
        self$`assigned_governmental_fund_balance` <- MunicipalityFinancialObject$`assigned_governmental_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`total_governmental_fund_balance`)) {
        self$`total_governmental_fund_balance` <- MunicipalityFinancialObject$`total_governmental_fund_balance`
      }
      if (!is.null(MunicipalityFinancialObject$`general_fund_revenues`)) {
        self$`general_fund_revenues` <- MunicipalityFinancialObject$`general_fund_revenues`
      }
      if (!is.null(MunicipalityFinancialObject$`general_fund_expenditures`)) {
        self$`general_fund_expenditures` <- MunicipalityFinancialObject$`general_fund_expenditures`
      }
      if (!is.null(MunicipalityFinancialObject$`general_fund_revenues_over_under_expenditure`)) {
        self$`general_fund_revenues_over_under_expenditure` <- MunicipalityFinancialObject$`general_fund_revenues_over_under_expenditure`
      }
      if (!is.null(MunicipalityFinancialObject$`governmental_fund_revenues`)) {
        self$`governmental_fund_revenues` <- MunicipalityFinancialObject$`governmental_fund_revenues`
      }
      if (!is.null(MunicipalityFinancialObject$`governmental_fund_expenditures`)) {
        self$`governmental_fund_expenditures` <- MunicipalityFinancialObject$`governmental_fund_expenditures`
      }
      if (!is.null(MunicipalityFinancialObject$`governmental_fund_revenues_over_under_expenditure`)) {
        self$`governmental_fund_revenues_over_under_expenditure` <- MunicipalityFinancialObject$`governmental_fund_revenues_over_under_expenditure`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(MunicipalityFinancialJson) {
      MunicipalityFinancialObject <- jsonlite::fromJSON(MunicipalityFinancialJson, simplifyDataFrame = FALSE)
      self$setFromList(MunicipalityFinancialObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`fiscal_year`)) {
        self$`fiscal_year` <- listObject$`fiscal_year`
      }
      else {
        self$`fiscal_year` <- NA 
      }

      if (!is.null(listObject$`current_assets`)) {
        self$`current_assets` <- listObject$`current_assets`
      }
      else {
        self$`current_assets` <- NA 
      }

      if (!is.null(listObject$`non_current_assets`)) {
        self$`non_current_assets` <- listObject$`non_current_assets`
      }
      else {
        self$`non_current_assets` <- NA 
      }

      if (!is.null(listObject$`deferred_outflows`)) {
        self$`deferred_outflows` <- listObject$`deferred_outflows`
      }
      else {
        self$`deferred_outflows` <- NA 
      }

      if (!is.null(listObject$`total_assets`)) {
        self$`total_assets` <- listObject$`total_assets`
      }
      else {
        self$`total_assets` <- NA 
      }

      if (!is.null(listObject$`total_assets_plus_deferred_outflows`)) {
        self$`total_assets_plus_deferred_outflows` <- listObject$`total_assets_plus_deferred_outflows`
      }
      else {
        self$`total_assets_plus_deferred_outflows` <- NA 
      }

      if (!is.null(listObject$`current_liabilities`)) {
        self$`current_liabilities` <- listObject$`current_liabilities`
      }
      else {
        self$`current_liabilities` <- NA 
      }

      if (!is.null(listObject$`current_portion_of_long_term_debt`)) {
        self$`current_portion_of_long_term_debt` <- listObject$`current_portion_of_long_term_debt`
      }
      else {
        self$`current_portion_of_long_term_debt` <- NA 
      }

      if (!is.null(listObject$`net_pension_liability`)) {
        self$`net_pension_liability` <- listObject$`net_pension_liability`
      }
      else {
        self$`net_pension_liability` <- NA 
      }

      if (!is.null(listObject$`net_opeb_liability`)) {
        self$`net_opeb_liability` <- listObject$`net_opeb_liability`
      }
      else {
        self$`net_opeb_liability` <- NA 
      }

      if (!is.null(listObject$`all_other_long_term_debt`)) {
        self$`all_other_long_term_debt` <- listObject$`all_other_long_term_debt`
      }
      else {
        self$`all_other_long_term_debt` <- NA 
      }

      if (!is.null(listObject$`total_liabilities`)) {
        self$`total_liabilities` <- listObject$`total_liabilities`
      }
      else {
        self$`total_liabilities` <- NA 
      }

      if (!is.null(listObject$`deferred_inflows`)) {
        self$`deferred_inflows` <- listObject$`deferred_inflows`
      }
      else {
        self$`deferred_inflows` <- NA 
      }

      if (!is.null(listObject$`total_liabilities_plus_deferred_inflows`)) {
        self$`total_liabilities_plus_deferred_inflows` <- listObject$`total_liabilities_plus_deferred_inflows`
      }
      else {
        self$`total_liabilities_plus_deferred_inflows` <- NA 
      }

      if (!is.null(listObject$`total_net_position`)) {
        self$`total_net_position` <- listObject$`total_net_position`
      }
      else {
        self$`total_net_position` <- NA 
      }

      if (!is.null(listObject$`total_unrestricted_net_position`)) {
        self$`total_unrestricted_net_position` <- listObject$`total_unrestricted_net_position`
      }
      else {
        self$`total_unrestricted_net_position` <- NA 
      }

      if (!is.null(listObject$`total_expenses`)) {
        self$`total_expenses` <- listObject$`total_expenses`
      }
      else {
        self$`total_expenses` <- NA 
      }

      if (!is.null(listObject$`charges_for_services`)) {
        self$`charges_for_services` <- listObject$`charges_for_services`
      }
      else {
        self$`charges_for_services` <- NA 
      }

      if (!is.null(listObject$`operating_grants_and_contributions`)) {
        self$`operating_grants_and_contributions` <- listObject$`operating_grants_and_contributions`
      }
      else {
        self$`operating_grants_and_contributions` <- NA 
      }

      if (!is.null(listObject$`capital_grants_and_contributions`)) {
        self$`capital_grants_and_contributions` <- listObject$`capital_grants_and_contributions`
      }
      else {
        self$`capital_grants_and_contributions` <- NA 
      }

      if (!is.null(listObject$`general_revenues`)) {
        self$`general_revenues` <- listObject$`general_revenues`
      }
      else {
        self$`general_revenues` <- NA 
      }

      if (!is.null(listObject$`other_revenues`)) {
        self$`other_revenues` <- listObject$`other_revenues`
      }
      else {
        self$`other_revenues` <- NA 
      }

      if (!is.null(listObject$`total_revenues`)) {
        self$`total_revenues` <- listObject$`total_revenues`
      }
      else {
        self$`total_revenues` <- NA 
      }

      if (!is.null(listObject$`change_in_net_assets`)) {
        self$`change_in_net_assets` <- listObject$`change_in_net_assets`
      }
      else {
        self$`change_in_net_assets` <- NA 
      }

      if (!is.null(listObject$`non_spendable_general_fund_balance`)) {
        self$`non_spendable_general_fund_balance` <- listObject$`non_spendable_general_fund_balance`
      }
      else {
        self$`non_spendable_general_fund_balance` <- NA 
      }

      if (!is.null(listObject$`restricted_general_fund_balance`)) {
        self$`restricted_general_fund_balance` <- listObject$`restricted_general_fund_balance`
      }
      else {
        self$`restricted_general_fund_balance` <- NA 
      }

      if (!is.null(listObject$`committed_general_fund_balance`)) {
        self$`committed_general_fund_balance` <- listObject$`committed_general_fund_balance`
      }
      else {
        self$`committed_general_fund_balance` <- NA 
      }

      if (!is.null(listObject$`unassigned_general_fund_balance`)) {
        self$`unassigned_general_fund_balance` <- listObject$`unassigned_general_fund_balance`
      }
      else {
        self$`unassigned_general_fund_balance` <- NA 
      }

      if (!is.null(listObject$`assigned_general_fund_balance`)) {
        self$`assigned_general_fund_balance` <- listObject$`assigned_general_fund_balance`
      }
      else {
        self$`assigned_general_fund_balance` <- NA 
      }

      if (!is.null(listObject$`total_general_fund_balance`)) {
        self$`total_general_fund_balance` <- listObject$`total_general_fund_balance`
      }
      else {
        self$`total_general_fund_balance` <- NA 
      }

      if (!is.null(listObject$`non_spendable_governmental_fund_balance`)) {
        self$`non_spendable_governmental_fund_balance` <- listObject$`non_spendable_governmental_fund_balance`
      }
      else {
        self$`non_spendable_governmental_fund_balance` <- NA 
      }

      if (!is.null(listObject$`restricted_governmental_fund_balance`)) {
        self$`restricted_governmental_fund_balance` <- listObject$`restricted_governmental_fund_balance`
      }
      else {
        self$`restricted_governmental_fund_balance` <- NA 
      }

      if (!is.null(listObject$`committed_governmental_fund_balance`)) {
        self$`committed_governmental_fund_balance` <- listObject$`committed_governmental_fund_balance`
      }
      else {
        self$`committed_governmental_fund_balance` <- NA 
      }

      if (!is.null(listObject$`unassigned_governmental_fund_balance`)) {
        self$`unassigned_governmental_fund_balance` <- listObject$`unassigned_governmental_fund_balance`
      }
      else {
        self$`unassigned_governmental_fund_balance` <- NA 
      }

      if (!is.null(listObject$`assigned_governmental_fund_balance`)) {
        self$`assigned_governmental_fund_balance` <- listObject$`assigned_governmental_fund_balance`
      }
      else {
        self$`assigned_governmental_fund_balance` <- NA 
      }

      if (!is.null(listObject$`total_governmental_fund_balance`)) {
        self$`total_governmental_fund_balance` <- listObject$`total_governmental_fund_balance`
      }
      else {
        self$`total_governmental_fund_balance` <- NA 
      }

      if (!is.null(listObject$`general_fund_revenues`)) {
        self$`general_fund_revenues` <- listObject$`general_fund_revenues`
      }
      else {
        self$`general_fund_revenues` <- NA 
      }

      if (!is.null(listObject$`general_fund_expenditures`)) {
        self$`general_fund_expenditures` <- listObject$`general_fund_expenditures`
      }
      else {
        self$`general_fund_expenditures` <- NA 
      }

      if (!is.null(listObject$`general_fund_revenues_over_under_expenditure`)) {
        self$`general_fund_revenues_over_under_expenditure` <- listObject$`general_fund_revenues_over_under_expenditure`
      }
      else {
        self$`general_fund_revenues_over_under_expenditure` <- NA 
      }

      if (!is.null(listObject$`governmental_fund_revenues`)) {
        self$`governmental_fund_revenues` <- listObject$`governmental_fund_revenues`
      }
      else {
        self$`governmental_fund_revenues` <- NA 
      }

      if (!is.null(listObject$`governmental_fund_expenditures`)) {
        self$`governmental_fund_expenditures` <- listObject$`governmental_fund_expenditures`
      }
      else {
        self$`governmental_fund_expenditures` <- NA 
      }

      if (!is.null(listObject$`governmental_fund_revenues_over_under_expenditure`)) {
        self$`governmental_fund_revenues_over_under_expenditure` <- listObject$`governmental_fund_revenues_over_under_expenditure`
      }
      else {
        self$`governmental_fund_revenues_over_under_expenditure` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["fiscal_year"]] <- self$`fiscal_year`
      listObject[["current_assets"]] <- self$`current_assets`
      listObject[["non_current_assets"]] <- self$`non_current_assets`
      listObject[["deferred_outflows"]] <- self$`deferred_outflows`
      listObject[["total_assets"]] <- self$`total_assets`
      listObject[["total_assets_plus_deferred_outflows"]] <- self$`total_assets_plus_deferred_outflows`
      listObject[["current_liabilities"]] <- self$`current_liabilities`
      listObject[["current_portion_of_long_term_debt"]] <- self$`current_portion_of_long_term_debt`
      listObject[["net_pension_liability"]] <- self$`net_pension_liability`
      listObject[["net_opeb_liability"]] <- self$`net_opeb_liability`
      listObject[["all_other_long_term_debt"]] <- self$`all_other_long_term_debt`
      listObject[["total_liabilities"]] <- self$`total_liabilities`
      listObject[["deferred_inflows"]] <- self$`deferred_inflows`
      listObject[["total_liabilities_plus_deferred_inflows"]] <- self$`total_liabilities_plus_deferred_inflows`
      listObject[["total_net_position"]] <- self$`total_net_position`
      listObject[["total_unrestricted_net_position"]] <- self$`total_unrestricted_net_position`
      listObject[["total_expenses"]] <- self$`total_expenses`
      listObject[["charges_for_services"]] <- self$`charges_for_services`
      listObject[["operating_grants_and_contributions"]] <- self$`operating_grants_and_contributions`
      listObject[["capital_grants_and_contributions"]] <- self$`capital_grants_and_contributions`
      listObject[["general_revenues"]] <- self$`general_revenues`
      listObject[["other_revenues"]] <- self$`other_revenues`
      listObject[["total_revenues"]] <- self$`total_revenues`
      listObject[["change_in_net_assets"]] <- self$`change_in_net_assets`
      listObject[["non_spendable_general_fund_balance"]] <- self$`non_spendable_general_fund_balance`
      listObject[["restricted_general_fund_balance"]] <- self$`restricted_general_fund_balance`
      listObject[["committed_general_fund_balance"]] <- self$`committed_general_fund_balance`
      listObject[["unassigned_general_fund_balance"]] <- self$`unassigned_general_fund_balance`
      listObject[["assigned_general_fund_balance"]] <- self$`assigned_general_fund_balance`
      listObject[["total_general_fund_balance"]] <- self$`total_general_fund_balance`
      listObject[["non_spendable_governmental_fund_balance"]] <- self$`non_spendable_governmental_fund_balance`
      listObject[["restricted_governmental_fund_balance"]] <- self$`restricted_governmental_fund_balance`
      listObject[["committed_governmental_fund_balance"]] <- self$`committed_governmental_fund_balance`
      listObject[["unassigned_governmental_fund_balance"]] <- self$`unassigned_governmental_fund_balance`
      listObject[["assigned_governmental_fund_balance"]] <- self$`assigned_governmental_fund_balance`
      listObject[["total_governmental_fund_balance"]] <- self$`total_governmental_fund_balance`
      listObject[["general_fund_revenues"]] <- self$`general_fund_revenues`
      listObject[["general_fund_expenditures"]] <- self$`general_fund_expenditures`
      listObject[["general_fund_revenues_over_under_expenditure"]] <- self$`general_fund_revenues_over_under_expenditure`
      listObject[["governmental_fund_revenues"]] <- self$`governmental_fund_revenues`
      listObject[["governmental_fund_expenditures"]] <- self$`governmental_fund_expenditures`
      listObject[["governmental_fund_revenues_over_under_expenditure"]] <- self$`governmental_fund_revenues_over_under_expenditure`
      return(listObject)
    }
  )
)
